%%%%
%% Present_lib
%%%%

function s_out=addRoundKey(s_in, key)
  for i=1:4:64
    s_out(i:i+3) = dec2bin(bitxor(bin2dec(s_in(i:i+3)), bin2dec(key(i:i+3))), 4);
  end
end

function s_out=sboxLayer(s_in) % Encryption
  sbox=[12 5 6 11 9 0 10 13 3 14 15 8 4 7 1 2];
  for i=1:4:64
    s_out(i:i+3) = dec2bin(sbox(bin2dec(s_in(i:i+3))+1), 4);
  end
end

function s_out=sboxLayer_d(s_in) % Decryption
  sbox=[5 14 15 8 12 1 2 13 11 4 6 3 0 7 9 10];
  for i=1:4:64
    s_out(i:i+3) = dec2bin(sbox(bin2dec(s_in(i:i+3))+1), 4);
  end
end

function s_out=permutation(s_in) % Encryption
   Perm=[0 4 8 12 16 20 24 28 32 36 40 44 48 52 56 60 ...
         1 5 9 13 17 21 25 29 33 37 41 45 49 53 57 61 ...
         2 6 10 14 18 22 26 30 34 38 42 46 50 54 58 62 ...
         3 7 11 15 19 23 27 31 35 39 43 47 51 55 59 63];
  for i = 1:64
    s_out(i)=s_in(Perm(i)+1);
  end
end

function s_out=permutation_d(s_in) % Decryption
   Perm=[0 16 32 48 1 17 33 49 2 18 34 50 3 19 35 51 ...
         4 20 36 52 5 21 37 53 6 22 38 54 7 23 39 55 ...
         8 24 40 56 9 25 41 57 10 26 42 58 11 27 43 59 ...
         12 28 44 60 13 29 45 61 14 30 46 62 15 31 47 63];
  for i = 1:64
    s_out(i)=s_in(Perm(i)+1);
  end
end

function key_out=updateKey(key, i) % Encryption
  sbox=[12 5 6 11 9 0 10 13 3 14 15 8 4 7 1 2];
  key_out=[key(62:80) key(1:61)];
  key_out(1:4)=dec2bin(sbox(bin2dec(key_out(1:4))+1),4);
  key_out(61:65)=dec2bin(bitxor(i, bin2dec(key_out(61:65))), 5);  
end

function key_out=updateKey_d(key, i) % Decryption
  sbox=[5 14 15 8 12 1 2 13 11 4 6 3 0 7 9 10];
  key_out=key;
  key_out(61:65)=dec2bin(bitxor(i, bin2dec(key_out(61:65))), 5);
  key_out(1:4)=dec2bin(sbox(bin2dec(key_out(1:4))+1),4);  
  key_out=[key_out(20:80) key_out(1:19)];
end

%%%%
%% Encryption
%%%%
function C=Present_enc(P_in, K)
  S=P_in;
  K_s=K;
  for i=1:31
%    i
    S=addRoundKey(S, K_s(1:64));
    S=sboxLayer(S);
    S=permutation(S);
    K_s=updateKey(K_s, i);
  end
  C=addRoundKey(S, K_s(1:64));
end

%%%%
%% Decryption
%%%%
function C=Present_dec(P_in, K)
  S=P_in;
  K_s=K;
  for i=1:31
     K_s=updateKey(K_s, i);
  end
  K_hex="";
  for i=1:4:64
    K_hex(end+1)=dec2hex(bin2dec(K_s(i:i+3)));
  end
  K_hex
  for i=31:-1:1
    i
    S=addRoundKey(S, K_s(1:64));
    S=permutation_d(S);
    S=sboxLayer_d(S);
    K_s=updateKey_d(K_s, i);
    S_hex="";
    K_hex="";
    for i=1:4:64
      S_hex(end+1)=dec2hex(bin2dec(S(i:i+3)));
      K_hex(end+1)=dec2hex(bin2dec(K_s(i:i+3)));
    end
    S_hex
    K_hex
  end
  C=addRoundKey(S, K_s(1:64));
end